.586
                    
_code   segment public use32 'CODE'
        assume  cs:_code,ds:_DATA,ss:_pile
                    
debut:                              
        mov ax,13h  
        int 10h     
            
        call init                   
        call souris      
                    
                            
fin:                                      
               
        xor ax,ax
        int 16h
                                          
        mov ax,04c00h                        
        int 21h                              
                                  
souris  proc                
        pusha               
                            
        call calcul_position_tete
        mov tempo,100
boucle_souris:      
        mov ax,03h          
        int 33h                
        mov x,cx              
        mov y,dx              
      
        mov cx,bx
        test cx,10b
        jne pas_test_quit
        cmp dx,1
        je fin_boucle_souris 


pas_test_quit:
        mov position_bouton,0
        test bx,1
        je pas_bouton_appuyer
        mov position_bouton,1
        call test_onatouchekelkun
                                 
pas_bouton_appuyer:              
                 
        call clear_screen
        call affichage_curseur
        call affichage_tete                         
        call affichage_score
        call affichage_buffer_ecran
            
                         
        mov si,tempo
        dec si      
        mov tempo,si
        cmp si,0    
        jne boucle_souris
                         
        call calcul_position_tete
        call affichage_tete
        mov tempo,100
        jmp boucle_souris
                    
                            
fin_boucle_souris:                                 
                    
        popa                     
        ret                      
        endp souris              
               
affichage_score proc
        pusha  
        mov eax,buffer_ecran
;on color en vert (86)
        mov bl,86
        mov bh,score 
coloration:          
        mov [eax],bl
        inc eax                      
        dec bh        
        jnz coloration
               
;on color le reste en rouge (28)
        mov bl,28
        mov bh,15
        sub bh,score
coloration_2:
        mov [eax],bl
        inc eax                      
        dec bh        
        jnz coloration_2
               
        popa                
        ret                 
        endp affichage_score
                                 
test_onatouchekelkun proc        
        pusha               
        mov cx,x    
        add cx,25   
        mov dx,x_tete
        cmp cx,dx   
        jb pas_touche
        add dx,40   
        cmp cx,dx   
        ja pas_touche
                    
        mov cx,y    
        mov dx,y_tete
        cmp cx,dx             
        jb pas_touche         
        add dx,40             
        cmp cx,dx             
        ja pas_touche         
;on a touche kelkun           
;on regarde si cetait un tox ou non et on modifie le score
;si tox > 8 alors cest pas un tox        
        cmp tox,9             
        jge pasuntox
        add score,2           
pasuntox:                     
        dec score   
        mov tempo,100         
                              
        call calcul_position_tete

        mov bl,score          
        cmp bl,0              
        je perdu              
                              
        cmp bl,15             
        je gagne              
                              
pas_touche:                   
        popa                                 
        ret                      
perdu:                        
        lea ecx,text_perdu    
        jmp fin_jeu           
gagne:                        
        lea ecx,text_gagne    
fin_jeu:                      
        mov ax,03h            
        int 10h               
        mov ebx,0b8000h       
boucle_affichage_text_fin:        
        mov dl,[ecx]          
        cmp dl,1              
        je fin                
        mov [ebx],dl          
        inc ecx               
        add ebx,2             
        jmp boucle_affichage_text_fin
                              
                              
        endp test_onatouchekelkun
                                 
affichage_curseur proc           
;entree:                         
;       x,y,couleur              
;sortie:                         
;       affichage en x,y a la couleur
        pusha                        
                                     
        movzx eax,x                  
        movzx ebx,y                  
        lea ebx,[ebx+ebx*4]          
        shl ebx,6                    
        add ebx,eax                  
        add ebx,buffer_ecran;0a0000h              
                              
;on va chercher le graph             
        mov eax,buffer_seringue_1    
        mov cl,position_bouton       
        cmp cl,1                     
        je bouton_pas_appuye         
        add eax,50                   
bouton_pas_appuye:                   
                              
                         
        mov cl,50        
        mov ch,50        
affichage_seringue:        
        mov dl,[eax]     
        cmp dl,203       
        je pas_affichage 
        mov [ebx],dl     
                         
pas_affichage:           
        inc eax          
        inc ebx          
                         
        dec cl           
        jnz affichage_seringue
                         
        add eax,320-50+320       
        add ebx,320-50   
        mov cl,50                          
                         
        dec ch           
        jnz affichage_seringue
                                      
                         
        popa                  
        ret                   
        endp affichage_curseur
                              
affichage_buffer proc near
;entree:                        
;       edi : coordonnee d entree
;sortie:                 
;       affichage du buffer 64Ko
                         
        pusha            
                                  
        mov eax,0a0000h          
        mov cx,0FFFFh    
boucle_affichage_buffer_1:
        mov bl,[edi]     
        mov [eax],bl     
        inc eax          
        inc edi     
        dec cx                      
        jnz boucle_affichage_buffer_1         
                             
        popa                 
        ret                  
        endp affichage_buffer                
                    
calcul_position_tete proc
;on choisit au hasard une tete, une coordonnee x et y, on affiche
;il reste plus que a choisir un temps que sa va rester =)
                                 
        pusha                    
        call randomize           
        mov ax,random            
                                 
;on choisit le numero du tox     
        call randomize           
        mov ax,random            
        and al,01111b            
        mov tox,al               
                      
                      
;il reste plus que a choisir les x et y
        call randomize
        mov ax,random 
        and ax,0FFh   
        mov x_tete,ax 
        call randomize
        mov ax,random 
        and ax,0FFh   
        cmp ax,160
        jna pas_trop_bas
        mov ax,150               
pas_trop_bas:        
                    
        mov y_tete,ax 
        popa        
                    
        ret         
        endp calcul_position_tete
                                 
                                 
affichage_tete proc              
        pusha       
                
;on affiche           
        movzx eax,x_tete
        movzx ebx,y_tete
        lea ebx,[ebx+ebx*4]
        shl ebx,6       
        add ebx,eax
        add ebx,buffer_ecran;0a0000h
                                 
;on cherche l img 
        mov esi,buffer_pcx
        movzx cx,tox
;on mul par 40   
        mov edx,ecx
        shl edx,5   
        shl ecx,3   
        add ecx,edx 
        add esi,ecx     ;en esi la coordonnee de la tete du gars
                    
        mov dx,3dah   
@wait1_2:           
        in al,dx      
        and al,8h     
        jnz @wait1_2
                    
                    
        mov cl,40
        mov ch,40
boucle_affichage_tete:           
        mov dl,[esi]
        mov [ebx],dl
        inc esi
        inc ebx        
               
        dec cl      
        jnz boucle_affichage_tete
        add esi,320-40+320
        add ebx,320-40
        mov cl,40                
        dec ch                   
        jnz boucle_affichage_tete
                 
               
        popa      
        ret                
        endp affichage_tete
                           
clear_screen proc near
        pusha                    
            
        mov eax,buffer_ecran
        mov dl,0
        mov cx,0FFFFh
boucle_clear_screen: 
        mov [eax],dl 
        inc eax      
        dec cx
        jnz boucle_clear_screen
            
        popa
        ret                    
        endp clear_screen      
                                 
affichage_pcx proc near    
        lea eax,debut_pcx  
        add eax,128     ;enlever + tard
                                
        mov ebx,buffer_pcx   
        mov ecx,320*90*2
boucle_affichage_pcx:           
        mov dl,[eax]                
        cmp dl,0c0h          
        jb suite2            
                             
        and dl,00111111b            
        inc eax                     
        jmp suite3                  
suite2:                                       
        mov dl,1                             
suite3:                             
        mov dh,[eax]                
boucle_45:                          
        mov [ebx],dh                
        inc ebx                     
        dec ecx                      
        cmp ecx,0                    
        je fin_boucle_affichage_pcx 
        dec dl                     
        jnz boucle_45              
                                   
        inc eax                    
        jmp boucle_affichage_pcx
                                   
fin_boucle_affichage_pcx:    
        lea ebx,fin_pcx
        sub ebx,768  
                                    
;on charge la palette du pcx                  
        xor ax,ax            
        mov dx,3c8h          
        out dx,al            
        mov dx,3c9h          
        mov cx,256*3             
boucle_palette_pcx:             
        mov al,[ebx]         
        shr al,2             
        out dx,al            
        inc ebx              
        dec cx                    
        jnz boucle_palette_pcx
                                             
        ret                                  
        endp affichage_pcx                   
                    
affichage_buffer_ecran proc
        pusha
        mov ebx,buffer_ecran
        mov eax,0a0000h
        mov cx,0FFFFh
boucle_affichage_buffer_ecran:        
        mov dl,[ebx]
        mov [eax],dl
        inc ebx   
        inc eax                      
        dec cx                           
        jnz boucle_affichage_buffer_ecran
        popa
        ret     
        endp affichage_buffer_ecran
                               
init    proc near              
        mov ax,13h             
        int 10h                
                                    
        mov ebx,esp                           
        add ebx,200h           
        mov buffer_pcx,ebx      ;pour trouver ou se trouve ce buffer
        mov pcx_tox,ebx                
        add ebx,320*40         
        mov pcx_non_tox,ebx    
        add ebx,320*40         
        mov buffer_seringue_1,ebx
        add ebx,320*50*2
        mov buffer_ecran,ebx   
                               
;on balance le pcx en memoire  
        call affichage_pcx        
           
        in ax,40h       ;on init la procedure de random
        mov random,ax
           
;on definit la difference de distance de la souris horizontal
        mov ax,7h
        mov cx,0
        mov dx,280 
        int 33h
           

        mov ax,03h          
        int 33h                

        ret                    
        endp init              
                      
randomize proc        
        pusha    
        in ax,40h                
        mov bx,random
        mov cl,al    
        rol bx,cl    
        xor bx,ax    
        mov random,bx                      
        popa
        ret           
        endp randomize             
                     
                     
_code   ends                                     
                                                 
_data   segment dword use32 'DATA'               
text_gagne db "Bravo tu as pique assez de toxico !!!! (score = 10)",01
text_perdu db "Tu as perdu : tu a pique trop de non t0X!!!! (score = -5)",01
                     
x       dw 0         
y       dw 0         
couleur db 0         
              
USMOFFSET dd 0                   
             
x_tete dw (?)
y_tete dw (?)
tox     db (?)   

position_bouton db (?)
                 
score db 5
         
tempo dw ?
buffer_seringue_1 dd (?)
buffer_seringue_2 dd (?)
random dw (?)
pcx_tox dd (?)       
pcx_non_tox dd (?)
buffer_pcx dd (?)                                
buffer_ecran dd (?)   
                                          
debut_pcx db ''
include final3.bin
fin_pcx db ''         
 
;seringue db ''
;include seringue.bin
;seringue_fin db ''
                 
                                 
_data    ends 
                               
_pile   segment dword use32 'STACK'
        dw 100h dup(?)   
_pile   ends    

fond_ecran segment dword use32 ;'STACK'
        db 320*200*10 dup(?)
fond_ecran ends
         
        end debut
                
